//typedef unsigned char uchar;
#include "fixed.hpp"

//#define PI _DBL2LONG_(3.141592654)
//#define RAD(_a) ((2*(PI)*(_a))/360)
#define RAD(_a) ((2*((long)( 3.141592654 * _BITS_ ))*(_a))/360)
//#define NUM_STATES 10

struct Trail {
	int x, y;
	int color;
	unsigned long decayRound;
	Trail *prev;
};

enum states {blank = 0, //EGA_BLACK ,
				 food = 2, //EGA_GREEN ,
				 crap = 4, // EGA_RED ,
				 body = 15, //EGA_WHITE ,
				 trail =  EGA_MAGENTA }; //EGA_DARKGREY };

struct st {
	unsigned char state;
	states dropColor;
	char dir;
	uchar amount;
	};

class ant //: Object
	{
	static Trail *thead;
	static Trail *ttail;
	void insertTrail(int color, int drop);

//	float x,y;
	fixed x,y;
	int dir;
	unsigned char state;
	states curCell;
	states oldCurCell;

	void correctXY();
//	void getXY (float &x, float &y);
	void getXY (fixed &x, fixed &y);

	public:
	static void updateTrails();
	static void delTrails();
	static unsigned long turn;
	static unsigned int round;

//	struct dirs dirTab[5][NUM_STATES];
//	struct st stateTab[5][NUM_STATES];
	struct st *stateTab[5];
	int score;
	int crapCount;

	~ant();
	ant();

	void move();
	void incScore(int _x) { score += _x; }
	void mate (ant *, ant *);
	ant *next;
	static ant *head;
};

